/* FRIEND.CPP */

/* Esimerkiss tehdn funktiot, jotka kertovat mahtuuko
   ympyr nelin ja pinvastoin.  Jottei tehtvst tulisi
   liian matemaattista, tutkitaan vain olioden kokoja.
   Oikeasti mielekkmpi tehtv tutkia leikkaavatko
   oliot toisiaan ja tllin tarvittaisiin tietysti
   mys keskipisteit
*/

#include <stdio.h>
#include <math.h>

class cNelio; // Eteenpin viittaus jotta void. kyt. ympyrss

class cYmpyra{
  double r; // Sde
public:
  cYmpyra(double d=1.0) { r = d; }
  friend mahtuuko(const cYmpyra &y, const cNelio &n);
  friend mahtuuko(const cNelio &n, const cYmpyra &y);
  friend mahtuuko(const cYmpyra &y1, const cYmpyra &y2);
};

class cNelio{
  double s; // Sivun pituus
public:
  cNelio(double d=1.0) { s = d; }
  friend mahtuuko(const cYmpyra &y, const cNelio &n);
  friend mahtuuko(const cNelio &n, const cYmpyra &y);
  friend mahtuuko(const cNelio &n1, const cNelio &n2);
};


int mahtuuko(const cYmpyra &y, const cNelio &n)
{
  return ( 2*y.r < n.s );
}

int mahtuuko(const cNelio &n, const cYmpyra &y)
{
  return ( sqrt(2.0)*n.s/2 < y.r );
}

int mahtuuko(const cYmpyra &y1, const cYmpyra &y2)
{
  return ( y1.r < y2.r );
}

int mahtuuko(const cNelio &n1,const cNelio &n2)
{
  return ( n1.s < n2.s );
}

int main(void)
{
  cNelio n1(2.1),n2(2.5); cYmpyra y1(0.9),y2(1.2);
  if ( mahtuuko(n1,y1) ) printf("Neli 1 mahtuu ympyrn 1 sislle.\n");
  if ( mahtuuko(y1,n1) ) printf("Ympyr 1 mahtuu nelin 1 sislle.\n");
  if ( mahtuuko(y1,y2) ) printf("Ympyrt mahtuvat siskkin.\n");
  if ( mahtuuko(n1,n2) ) printf("Nelit mahtuvat siskkin.\n");
  return 0;
}
