/* FRIEND2.CPP */

/* Esimerkiss tehdn funktiot, jotka kertovat mahtuuko
   ympyr nelin ja pinvastoin.
   Toteutus ystvluokan avulla.
*/

#include <iostream.h>
#include <math.h>

class cNelio; // Eteenpin viittaus jotta void. kyt. ympyrss

class cYmpyra{
  friend cNelio;
  double r; // Sde
public:
  cYmpyra(double d=1.0) { r = d; }
  int mahtuuko(const cNelio &n) const;
  int mahtuuko(const cYmpyra &y2) const {
    return ( r < y2.r );
  }
};


class cNelio{
  double s; // Sivun pituus
  friend cYmpyra;
public:
  cNelio(double d=1.0) { s = d; }
  int mahtuuko(const cYmpyra &y) const {
    return ( sqrt(2.0)*s/2 < y.r );
  }
  int mahtuuko(const cNelio &n2) {
    return ( s < n2.s );
  }
};


int cYmpyra::mahtuuko(const cNelio &n) const
{
  return ( 2*r < n.s );
}


int main(void)
{
  cNelio n1(2.1),n2(2.5); cYmpyra y1(0.9),y2(1.2);
  if ( n1.mahtuuko(y1) ) cout << "Neli 1 mahtuu ympyrn 1 sislle.\n";
  if ( y1.mahtuuko(n1) ) cout << "Ympyr 1 mahtuu nelin 1 sislle.\n";
  if ( y1.mahtuuko(y2) ) cout << "Ympyrt mahtuvat siskkin.\n";
  if ( n1.mahtuuko(n2) ) cout << "Nelit mahtuvat siskkin.\n";
  return 0;
}
