/*  LISTARR.CPP

Esimerkki (yksisuuntaisen) listan toteuttamisesta taulukon avulla.
Kaksi esimerkki mahdollisuuksista kyd lista kokonaan lpi.
  joko: for (c=l.first(); !l.out(); c=l.next() )  -> kyt c ??
  tai:  for (l.tobegin(); !l.out(); l.forward() ) -> kyt l.current()
Ei tapahdu "vahinkoa", vaikka listaa yritetn kytt liian pitklle.

vl 6.11.1993

Tehtvi 1) Peri luokasta luokka cList2, joka on kaksisuuntainen ja
            jossa voidaan siis liikkua kumpaankin suuntaan.

         2) Toteuta list "oikeana" dynaamisena listana.

         3) Peri tehtvn 2 listasta 2-suuntainen lista.
            Onnistuuko kunnolla?

         4) Mit tss pit muuttaa, mikli halutaan kytt
            muun tyyppisi listan alkioita?
            Kokeile reaalilukuja ja piste-luokan alkioita!
            (Piste-luokka ks. MYSTREAM.CPP)

         5) Ent jos halutaan kytt samassa ohjelmassa kahta
            tai useampaa eri listaan menev tyyppi?
*/

#include <iostream.h>

inline int inside(int a,int x,int b) // x vlille [a,b], jos b<a niin a
  { return b < a ? a : x < a ? a : x < b ? x : b; }

#define MAX_ELEM 100

#define TYPE char

class cList {
protected:
  int nelem;           // Alkioiden lukumr
  TYPE data[MAX_ELEM]; // Alkioden taulukko
  int cursor;          // Sijainti listassa
public:
  cList()                { nelem = 0; tobegin();                     }
  ~cList()               { nelem = 0;                                }

  int  out()       const { return ( cursor < 0 || nelem <= cursor ); }
  int  tobegin()         { cursor = 0;       return out();           }
  int  forward()         { ++cursor;         return out();           }
  int  toend()           { cursor = nelem-1; return out();           }
  TYPE current()   const { return data[inside(0,cursor,nelem-1)];    }
  TYPE first()           { tobegin(); return current();              }
  TYPE next()            { forward(); return current();              }
  TYPE last()            { toend();   return current();              }
  int  empty()     const { return ( nelem == 0 );                    }
  int  add(TYPE p)       { if ( nelem >= MAX_ELEM ) return 1;
                           data[nelem++] = p; return 0;
                         }
}; /* cList */


#define VIIVA "------------------------------------------------------------\n"
/****************************************************************************/
int main(void)
{
  cout << VIIVA;

  cList lc; lc.add('a'); lc.add('b'); lc.add('c'); lc.add('d');

  for (char c=lc.first(); !lc.out(); c=lc.next() )
    cout << c << " ";

  cout << c << "\n" << VIIVA;

  for (lc.tobegin(); !lc.out(); lc.forward() )
    cout << lc.current() << " ";

  cout << lc.current() << "\n" << VIIVA;

  return 0;
}
