/* OPERATO2.CPP  - malli copy construktorin ja hvittjn tutkimiseen */
#include <stdio.h>
#include <string.h>
/*
   Kokeile seuraavia:

   1) Yhteenlaskussa on tilapinen muuttuja t
   2) ei ole tilapist muuttujaa t
   3) sijoitus on tyyppi cPaikka &
   4) sijoitus on tyyppi cPaikka
   5) sijoitus on tyyppi void
   6) yhteenlaskun parametri on tyyppi cPaikka eik cPaikka &
      palauta tmn jlkeen tyypiksi takaisin cPaikka &
   7) lis pohjelmaan sijoitus p4 = p3 = p2 = p1
   8) edellinen ketjusijoitus sek sijoitus tyyppi cPaikka
   9) kokeile viel kommentoida copy contructori pois kun
      tilapinen yhteenlaskumuuttuja on kytss.  Miten selitt
      tilanteen?

   Kuinka monta tilapist (ei itse mritelty) oliota syntyy
   kussakin tapauksessa + operaatiosta,  sijoitusoperaatiosta
   ja uhteens.  Eli normaalisti laskusta p4=p1+p2 kyttj
   olettaa 3 olion osallistuvan laskutoimitukseen.  Jos laskun
   aikana on esim. kytss 6 oliota, on nist yhteens
   3 "ylimrist" (joista 2 voi olla +:n takia ja 1 =:n takia).

   Tyt tuloksista alla oleva taulukko ja tee ptelm mik on
   paras tapa hoitaa sijoitus ja mik yhteenlasku.
   Ent jos laskuoperaatio on matriisilasku, jossa vlttmtt
   tarvitaan apumuuttuja?

   ----------------------------
   |  | p4=p1+p2  |p4=p1+p2+p3|
   |  | + | = |yht| + | = |yht|
   |--+---+---+---+---|---|---|
   |1)|   |   |   |   |   |   |
   |2)|   |   |   |   |   |   |
   |3)|   |   |   |   |   |   |
   |4)|   |   |   |   |   |   |
   |5)|   |   |   |   |   |   |
   |6)|   |   |   |   |   |   |
   |7)|   |   |   |   |   |   |
   |8)|   |   |   |   |   |   |
   |9)|   |   |   |   |   |   |
   ----------------------------

*/

class cPaikka {
  int x,y;
  char nimi[20];
  static int paikkoja;

  void nimea(char *s="") { // Oletuksena pisteiden mr + this -osoite
    paikkoja++;
    if ( s[0] ) sprintf(nimi,"%02d-%s",paikkoja,s);
    else sprintf(nimi,"%02d-%04p",paikkoja,this);
  }

  void tulosta() const { printf("(%d,%d) -- %-10.9s ",x,y,nimi);  }

  void rivi(char *s,char *v="",cPaikka *p=NULL) const {
    printf("%-20s : ",s);
    if ( p ) { p->tulosta(); printf(" %-3s ",v); }
    tulosta();
    if ( v[0] == 'j' ) printf("  jljell %d",paikkoja);
    else printf("%s%s%s",v,v,v);
    printf("\n");
  }

public:
  cPaikka() {x=0; y=0; nimea(); rivi("Empty constructor");  }
  cPaikka(int ix,int iy,char *s="") {
    x = ix; y=iy; nimea(s);
    rivi("Norm.constructor");
  }
#if 1
  cPaikka(cPaikka &p) {
    x=p.x; y=p.y; nimea();
    rivi("Copy constructor","->",&p);
  }
#endif

  ~cPaikka() {paikkoja--; rivi("Hvittj","j"); }

  cPaikka operator+(cPaikka &p);
  cPaikka &operator=(cPaikka &p);

};

cPaikka cPaikka::operator+(cPaikka &p)
{
#if 1
  rivi("Yhteenlasku apum"," +",&p);

  cPaikka t(0,0,"t");;

  t.x = x + p.x;
  t.y = y + p.y;
  return t;
#else
  rivi("Yhteenlasku ei apum"," +",&p);
  return cPaikka( x + p.x, y+ p.y );
#endif
}


cPaikka &cPaikka::operator=(cPaikka &p)
{
  rivi("Sijoitus","->",&p);

  x = p.x; y = p.y;
  return *this;
}


int cPaikka::paikkoja = 0;


int main(void)
{
  printf("---------------------------------------------------------------\n");
  cPaikka p1(2,2,"p1"),p2(1,4,"p2"),p3(2,1,"p3"),p4(0,0,"p4");
  printf("p4 = p1 + p2:--------------------------------------------------\n");
  p4 = p1 + p2;
#if 0
  printf("p4 = p1 + p2 + p3:---------------------------------------------\n");
  p4 = p1 + p2 +p3;
#endif
  printf("Ohjelman loppu:------------------------------------------------\n");
  return 0;
}

